REM gUi1A2A3jmF

option angle radians
option arithmetic complex  ! f[hɐݒ

REM ============= p[^ =============
REM Ul
let lambdaZero = 1550   ! M̔gi0j [nm]
let disp = 16           ! 0ɂt@Co̕Ul [ps/(nm km)]
let dSlope = 0.06       ! 0ɂt@Co̕UX[v [ps/(nm^2 km)]
REM 萔֘A
let speedOfLight = 2.99792458e8  ! ^󒆂̌ [m/s]
REM vZ͈
let wStart = 1200 ! Jn [nm]
let wStop = 1600  ! I [nm]
let dn = 400      ! 
REM ============== ܂ ==============

REM ۂɌvZf[^
let dn = dn + 1   ! f[^͕{1

REM g/ge[u̍쐬
REM wavelength(n) ̂Ƃ̎g freq(n) ƂȂ
dim wavelength(dn)   ! [nm]
for k=1 to dn
   let wavelength(k) = wStart + (wStop-wStart)/(dn-1) * (k-1)
   ! g𓙊ԊuŃXg쐬
next k
let fZero = speedOfLight / (lambdaZero*1e-9) ! [Hz]
dim freq(dn)   ! [Hz]
for k=1 to dn
   let freq(k) = speedOfLight / (wavelength(k)*1e-9)
   let freq(k) = freq(k) - fZero
   ! gLAg̕΍Ƃ
next k

REM 0ɂpg/gϊW
let nm2rad = -2 * pi * speedOfLight / (lambdaZero*1e-9)^2 * 1e-9
   ! [(rad/sec)/m * 1e-9] = [rad/(sec nm)]
   ! ł͕܂݁A̒lƂȂ

REM ̒`
let beta0 = 0  ! ʑItZbg
let beta1 = 0  ! Qx [sec/km]
let beta2 = disp * 1e-12 / nm2rad         ! U[sec sec/(rad km)]
let beta3 = dSlope * 1e-12 / (nm2rad^2)   ! UX[v[sec^3/(rad^2 km)]

REM LApg̎Ńe[[WJAQxAU
REM omega ɑ΂֐ƂĒ`
REM Aomega ͂ł̓LApg̃ItZbg
def beta(omega) = beta0 + beta1*omega + 1/2*beta2*omega^2 + 1/6*beta3*omega^3
! exp(-L)ʑpӁ- ƂȂ
def groupDelay(omega) = beta1 + beta2*omega + 1/2*beta3*omega^2
! Qxg[sec/km]  -d/d = d/d
def dispersion(omega) = beta2 + beta3*omega
! U D = dg/d
!        = [(sec/km)/omega] = [(sec/km)/(rad/sec)] = [sec sec/(rad km)]

REM Qx̌vZ
dim gd(dn)
for k = 1 to dn
   gd(k) = groupDelay( 2*pi*freq(k) ) * 1e9  ! [nsec / km]
next k
REM gU(CD)̌vZ
dim cd(dn)
for k = 1 to dn
   cd(k) = dispersion( 2*pi*freq(k) )  ! [sec^2/(rad km)]
   cd(k) = cd(k) * nm2rad * 1e12       ! [psec/(nm km)]
next k
! ɂACfbNXԍ n }ɁA
! wavelength(n), freq(n), gd(n), cd(n)
! Ή

REM Ot\
set bitmap size 485, 300   ! `̈ɐݒ
let xmin = wStart
let xmax = wStop
REM Qx
let ymin = -4
let ymax = 4
clear
set window xmin, xmax, ymin, ymax
let xi = 50  ! X [nm]
let yi = 1   ! YObh [ns/km]
draw grid(xi, yi) 
set line color 15
plot lines: xmin+xi, ymin;    ! c̍쐬
plot lines: xmin+xi, ymax     ! yAbv
set text color 15
for y = ymin to ymax step yi
   plot text ,at xmin+xi, y : str$(y)  ! c̒l̕`
next y
set line color 2  ! 
for k=1 to dn
   plot lines: wavelength(k), gd(k);
next k
plot lines

input prompt "̃OtRs[܂H(Y/N)": yn$
if yn$="Y" or yn$="y" or yn$="1" then
   stop  ! ӁIF_uNbNŎs̏ꍇӖ
end if

REM U
let ymin = -20
let ymax = 20
clear
set window xmin, xmax, ymin, ymax
let xi = 50 ! XObh[nm]
let yi = 5  ! YObh[ps/(nm km)]
draw grid(xi, yi)
set line color 15
plot lines: xmin+xi, ymin;    ! c̍쐬
plot lines: xmin+xi, ymax     ! yAbv
set text color 15
for y = ymin to ymax step yi
   plot text ,at xmin+xi, y : str$(y)  ! c̒l̕`
next y
set line color 4  ! 
for k=1 to dn
   plot lines: wavelength(k), cd(k);
next k
plot lines

pause
end
