REM NRZg`̐
REM o͔g`́AU +/-1,  0 ɋKiĂB
declare external function rising
declare external function falling
option angle radians

REM ==== p[^ ====
let ifname$ = "data\prbs_p0.txt"           ! ̓f[^t@Cl[
let ofname$ = "data\NRZwaveform.txt"    ! o̓f[^t@Cl[
let bitRate = 10e9  ! rbg[g [bit/sec]
let sn = 64         ! 1bit̃Tv
let tr = 100        ! 0-100% オ莞 [% of bit period]
let tf = 100        ! 0-100% 莞 [% of bit period]
let xp = 50         ! NX|Cg [%]
REM ===== ܂ =====

REM PRBSf[^̓ǂݍ
open #1: NAME ifname$
line input #1: tmp$
line input #1: tmp$
input #1: dn    ! PRBSf[^̓ǂݍ
dim prbs(dn)
mat prbs = ZER  ! z[ɏ
let k = 1
do
   input #1, if missing then exit do: prbs(k)
   let k = k + 1   ! Ɏۂ̃f[^1
loop
close #1
if dn <> k-1 then
   let dn = k-1
end if
REM g`vfiYj̍쐬iŏ, 0`1 ̐Uōj
if xp > 50 then   ! Trg`Tfg`قǂЂԂ
   let xx = tr
   let tr = tf
   let tf = xx
end if
dim zero2one(sn) ! オg`
for k = 1 to sn
   let  zero2one(k) = rising((k-1)/sn, tr)
next k
dim one2zero(sn) ! g`
for k = 1 to sn
   let  one2zero(k) = falling((k-1)/sn, tf)
next k
if xp <= 50 then    ! Xp̕ύXi50%ȉ̏ꍇj
   let xpc = log(xp/100) / log(0.5)
   for k = 1 to sn
      let one2zero(k) = one2zero(k)^xpc
      let zero2one(k) = zero2one(k)^xpc
   next k
else                ! Xp̕ύXi50%ȏ̏ꍇj
   let xpc = log(1 - xp/100) / log(0.5)
   for k = 1 to sn
      let one2zero(k) = 1 - one2zero(k)^xpc
      let zero2one(k) = 1 - zero2one(k)^xpc
   next k
   dim tmp(sn)
   mat tmp = one2zero
   mat one2zero = zero2one
   mat zero2one = tmp
end if
dim ones(sn)    ! 1x
mat ones = CON
dim zeros(sn)   ! 0x
mat zeros = ZER
REM g`̐iYj
let spn = dn * sn   ! STv|Cg
dim y(spn)      ! ŏIIɍ쐬ꂽg`z
dim nw(sn)      ! ̔g`vf邽߂̔z
! 1bit
if 0 = prbs(dn) then
   if 0 = prbs(1) then
      mat nw = zeros
   else
      mat nw = zero2one
   end if
else
   if 0 = prbs(1) then
      mat nw = one2zero
   else
      mat nw = ones
   end if
end if
let n = 1       ! z y p index
for k = 1 to sn
   let y(n) = nw(k)
   let n = n+1
next k
! 2bitڈȍ~
for j = 2 to dn
   if 0 = prbs(j-1) then
      if 0 = prbs(j) then
         mat nw = zeros
      else
         mat nw = zero2one
      end if
   else
      if 0 = prbs(j) then
         mat nw = one2zero
      else
         mat nw = ones
      end if
   end if
   for k = 1 to sn
      let y(n) = nw(k)
      let n = n+1
   next k
next j
REM x̒
for k = 1 to spn
   let  y(k) = 2 * y(k) -1
next k
REM Ԏf[^̐iTj
let bp = 1 / bitRate    ! 1rbg̎
let st = bp / sn        ! TvO
dim t(spn)
for k = 1 to spn
   let t(k) = st * (k-1)
next k
REM g`̃t@Cւ̕ۑ
open #1: NAME ofname$
erase #1
print #1: 2         ! ef[^̗vf
print #1: "REAL"    ! f[^^Cvivf1j
print #1: "REAL"    ! f[^^Cvivf2j
print #1: spn       ! f[^
for k=1 to spn
   print #1: t(k); ", ", y(k)
next k
close #1
print "Calculation completed."
end

REM x=[0->1], y=[0->1]ɋKiꂽオg`
REM オ莞(0-100%) tr[%] ɂĐłB
external function rising(x, tr)
option angle radians
if x < (1-tr/100)/2 then
   let y = 0
else
   if x >= 1-(1-tr/100)/2 then
      let y = 1
   else
      let y=0.5-0.5*cos(pi*(x-(1-tr/100)/2)/(tr/100))
   end if
end if
let rising = y
end function

REM x=[0->1], y=[1->0]ɋKiꂽg`
REM オ莞(0-100%) tr[%] ɂĐłB
external function falling(x, tf)
option angle radians
if x < (1-tf/100)/2 then
   let y = 1
else
   if x >= 1-(1-tf/100)/2 then
      let y = 0
   else
      let y=0.5+0.5*cos(pi*(x-(1-tf/100)/2)/(tf/100))
   end if
end if
let falling = y
end function
