REM gǓvZ
REM `ʂ𖳎A
REM gUƌɂê݌vZ
REM UX[v܂łl

option angle radians
option arithmetic complex  ! f[hɐݒ
declare external sub rotateRight
declare external sub FFT
declare external sub IFFT

REM ============= p[^ =============
REM MёUl
let lambdaZero = 1550   ! M̔gi0j [nm]
let disp = 16           ! 0ɂt@Co̕Ul [ps/(nm km)]
let dSlope = 0.06       ! 0ɂt@Co̕UX[v [ps/(nm^2 km)]
! let att = 0.2           ! t@CoX [dB/km] (>=0) <- 
REM f[^t@C֘A
let ifname$ = "data\mzModOut.txt"      ! ͌Mf[^t@C
let ofname$ = "data\dispersionOut.txt" ! o͌Mf[^t@C
REM 萔֘A
let speedOfLight = 2.99792458e8  ! ^󒆂̌ [m/s]
REM ============== ܂ ==============

REM 0ɂ鑍Ul [ps/nm]̓
input prompt "U [ps/nm]": td
let fiberLen = td / disp   ! UX[vƂ̃oX̂ߋɊZ
print "t@Co "; fiberLen; " [km]"

REM f[^̓ǂݍ
print "Loading data..."
open #1: NAME ifname$
input #1: cn        ! 1f[^̗vfiQj
line input #1: c1$  ! vf1̃^CviREALj
line input #1: c2$  ! vf2̃^CviCOMPLEXj
input #1: dn        ! f[^̓ǂݍ
dim t(dn)
dim e(dn)
let k = 1
do
   input #1, if missing then exit do: t(k), real, imag
   let e(k) = complex(real, imag)
   let k = k + 1   ! Ɏۂ̃f[^1
loop
close #1
if dn <> k-1 then ! ǂݍ񂾃f[^ dn ƈႤꍇ
   let dn = k-1
end if
print "Complete loading data."

REM XyNgpge[u̍쐬
dim freq(dn)
let maxFreq = ( 1/(t(2) - t(1)) ) / 2     ! ԊuTvOO
for k=1 to dn
   let freq(k) = (k-dn/2) * maxFreq / (dn/2)
next k

REM t@CoU`B֐ƌW̍쐬
dim fiberS21(dn)
let nm2rad = -2 * pi * speedOfLight / (lambdaZero*1e-9)^2 * 1e-9
!   nm2rad ͕̌WƂȂĂ܂B
!let alpha = log(10^(att/20))  ! W
let alpha = 0  ! Ȃ
let beta0 = 0  ! ʑItZbg
let beta1 = 0  ! Qx [sec/km]
let beta2 = disp * 1e-12 / nm2rad         ! U[sec sec/(rad km)]
let beta3 = dSlope * 1e-12 / (nm2rad^2)   ! UX[v[sec^3/(rad^2 km)]
for k = 1 to dn
   let omega = 2 * pi * freq(k)
   let beta = beta0 + beta1 * omega + 1/2*beta2 * omega^2 + 1/6*beta3 * omega^3
   fiberS21(k) = exp( -complex(alpha, beta) * fiberLen )
next k

REM FFTɂ镪Uƌ̌vZ
print "FFT calculation..."
call FFT(e)
call rotateRight(e, dn/2-1)
for k = 1 to dn
   e(k) = e(k) * fiberS21(k)
next k
call rotateRight(e, -(dn/2-1))
call IFFT(e)

REM ʂ̕ۑ
open #1: NAME ofname$
erase #1
print #1: 2          ! ef[^̗vf
print #1: "REAL"     ! f[^^Cvivf1j
print #1: "COMPLEX"  ! f[^^Cvivf2j
print #1: dn         ! f[^
for k=1 to dn
   print #1: t(k); ", ", re( e(k) ), ", ", im( e(k) )
next k
close #1

print "Calculation completed."

end

REM 1zVtg֐
REM   x: VtgzA߂l㏑
REM   d: VtgʁiFEVtgAFVtgj
external sub rotateRight(x(), d)
option arithmetic complex     ! f[hɐݒ
let n = size(x)
if n <= abs(d) then
   print "Error: d  x ͈̔͂𒴂Ă܂ rotateRight()"
   stop
end if
dim xtemp(abs(d))
if d > 0 then
   for k = 1 to d
      let  xtemp(k) = x(n - d + k)
   next k
   for k = n to d+1 step -1
      let  x(k) = x(k-d)
   next k
   for k = d to 1 step -1
      let  x(k) = xtemp(k)
   next k
else  ! d <= 0 ̂Ƃ
   for k = 1 to -d
      let  xtemp(k) = x(k)
   next k
   for k=1 to n + d
      let  x(k) = x(k-d)
   next k
   for k = (n+d) + 1 to n
      let  x(k) = xtemp(k - (n+d))
   next k
end if
end sub


REM t[GϊiFFT, IFFTj
REM   x: /o̓f[^AAfǂł悢
REM      f[^2ׂ̂{Ƃق
REM   vZʂ͓̓f[^㏑`ŗ^
REM   DFŤvŹAvfԍ K=1...N ɑ΂
REM   Xk = Sigma[n=1...N] (xn * W^((k-1)*(n-1)) )         ϊ
REM   xk = 1/N * Sigma[n=1...N] (xn * W^(-(k-1)*(n-1)) )  tϊ
REM   W = exp(-j * 2*pi/N)
REM   Ăяo option base 1 ɂĎgp̂
REM   ۂ FFT vŹAFFTMAIN ɂčs
external sub FFT(x())
option arithmetic complex     ! f[hɐݒ
declare external sub FFTMAIN
let xn = size(x)
let theta = -2 * pi / xn   ! W = exp(-j * i*pi/N) = exp(j * theta)Ƃ
call FFTMAIN(x, theta)
end sub

external sub IFFT(x())
option arithmetic complex     ! f[hɐݒ
declare external sub FFTMAIN
let xn = size(x)
let theta = 2 * pi / xn    ! W = exp(-j * i*pi/N * -1) = exp(j * theta)Ƃ
call FFTMAIN(x, theta)
mat x = (1/xn) * x
end sub

external sub FFTMAIN(x(), theta)
option arithmetic complex     ! f[hɐݒ
let xn = size(x)
if remainder(xn, 2)<>0 then
   ! DFŤvZ
   dim w(xn), xtmp(xn)
   mat xtmp = x
   for k = 1 to xn
      let tmp = theta * (k-1)
      for n = 1 to xn
         let w(n) = exp( complex(0, tmp * (n-1)) )
      next n
      let x(k) = dot(w, xtmp)
   next k
else
   ! zQčċAďo
   let hxn = xn/2
   dim x0(hxn), x1(hxn)
   for k=1 to hxn
      let x0(k) = x(k) + x(k+hxn)
      let wk = exp( complex(0, theta * (k-1)) )
      let x1(k) = wk * ( x(k) - x(k+hxn) )
   next k
   let theta0 = 2 * theta
   call FFTMAIN(x0, theta0)
   let theta1 = 2 * theta
   call FFTMAIN(x1, theta1)
   for k=1 to hxn
      let x(2*k-1) = x0(k)
      let x(2*k) = x1(k)
   next k
end if
end sub
